> ## Documentation Index
> Fetch the complete documentation index at: https://docs.maia.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# List streaming pipeline definitions

> Gets a page of streaming pipeline definitions in the account and project



## OpenAPI

````yaml /openapi/public-api-endpoint-reference.yaml get /v1/projects/{projectId}/streaming-pipelines
openapi: 3.1.0
info:
  title: Maia Public REST API
  version: '1.0'
servers:
  - description: EU1
    url: https://eu1.api.matillion.com/dpc
  - description: US1
    url: https://us1.api.matillion.com/dpc
security:
  - bearerAuth: []
tags:
  - description: Manage Schedules
    name: Schedules
  - description: Manage Connections
    name: Connections
  - description: Operations for managing Project Variables
    name: Project Variables
  - description: Manage Pipelines
    name: Pipelines
  - description: Review pipelines against quality rules
    name: Pipeline Quality Review
  - description: Execute tests within a project
    name: Test Execution
  - description: Manage your AI agent tasks
    name: AI Agent Tasks
  - description: SCIM endpoints for user/group permission management
    name: Directory Integration
  - description: Publish shared pipeline artifacts
    name: Shared Pipeline Artifacts
  - description: Manage Repositories
    name: Repositories
  - description: Report on Credit Consumption
    name: Consumption
  - description: Manage Artifacts
    name: Artifacts
  - description: Operations for data lineage and governance
    name: Data Lineage
  - description: Manage Streaming Pipelines
    name: Streaming Pipelines
  - description: Execute a pipeline
    name: Pipeline Execution
  - description: ''
    name: Environments
  - description: ''
    name: Projects
  - description: Manage Agents
    name: Agents
  - description: Operations for managing Environment-level Overrides of Project Variables
    name: Project Variable Environment Overrides
  - description: Query audit events
    name: Audit Events
  - description: Connector Profiles
    name: Connectors
paths:
  /v1/projects/{projectId}/streaming-pipelines:
    get:
      tags:
        - Streaming Pipelines
      summary: List streaming pipeline definitions
      description: Gets a page of streaming pipeline definitions in the account and project
      operationId: listStreamingPipelineDefinitions
      parameters:
        - description: >-
            The ID of the project in which to list the streaming pipeline
            definitions
          example: 12345678-1234-1234-1234-123456789012
          in: path
          name: projectId
          required: true
          schema:
            type: string
            format: uuid
        - description: Page number (0-indexed)
          example: '0'
          in: query
          name: page
          schema: {}
        - description: Number of records per page (from 1 to 100)
          example: '25'
          in: query
          name: size
          schema: {}
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/PagedResultListStreamingPipelineDefinition
          description: >-
            A page of streaming pipeline definitions. Possibly empty if no
            definitions exist in the account and project
        '400':
          content:
            application/problem+json:
              schema:
                $ref: '#/components/schemas/ProblemDetail'
          description: Bad Request
        '403':
          content:
            application/problem+json:
              schema:
                $ref: '#/components/schemas/ProblemDetail'
          description: Unauthorized
        '500':
          content:
            application/problem+json:
              schema:
                $ref: '#/components/schemas/ProblemDetail'
          description: Unexpected error occurred
components:
  schemas:
    PagedResultListStreamingPipelineDefinition:
      type: object
      properties:
        page:
          type: integer
          format: int32
          description: The 0-indexed page number of the returned results.
          example: 1
        results:
          type: array
          description: Page of results or empty.
          items:
            $ref: '#/components/schemas/StreamingPipelineDefinition'
        size:
          type: integer
          format: int32
          description: The size of each page of results.
          example: 50
        total:
          type: integer
          format: int64
          description: Total number of available results across all pages.
          example: 472
    ProblemDetail:
      type: object
      properties:
        detail:
          type: string
        instance:
          type: string
        status:
          type: integer
          format: int32
        title:
          type: string
        type:
          type: string
          format: uri
        violations:
          type: array
          items:
            type: string
    StreamingPipelineDefinition:
      type: object
      properties:
        advancedProperties:
          type: object
          additionalProperties:
            type: string
          description: Any additional properties for the streaming pipeline
          example:
            max.batch.size: 10000
        agentId:
          type: string
          format: uuid
          description: The ID of the agent that will run the streaming pipeline
          example: 12345678-1234-1234-1234-123456789012
        name:
          type: string
          description: The name of the streaming pipeline
          example: A Streaming Pipeline
        projectId:
          type: string
          format: uuid
          description: >-
            The ID of the project that contains the streaming pipeline
            definition
          example: 12345678-1234-1234-1234-123456789012
        streamingPipelineId:
          type: string
          format: uuid
          description: The ID of the streaming pipeline definition
          example: 12345678-1234-1234-1234-123456789012
        streamingSource:
          description: The details of the streaming source
          oneOf:
            - $ref: '#/components/schemas/StreamingDb2IbmISource'
            - $ref: '#/components/schemas/StreamingMySqlSource'
            - $ref: '#/components/schemas/StreamingOracleSource'
            - $ref: '#/components/schemas/StreamingPostgresSource'
            - $ref: '#/components/schemas/StreamingSqlServerSource'
        streamingTarget:
          description: The details of the streaming target
          oneOf:
            - $ref: '#/components/schemas/StreamingAbsTarget'
            - $ref: '#/components/schemas/StreamingS3Target'
            - $ref: '#/components/schemas/StreamingSnowflakeTarget'
    StreamingDb2IbmISource:
      allOf:
        - $ref: '#/components/schemas/StreamingSource'
        - type: object
          properties:
            connection:
              $ref: '#/components/schemas/StreamingDb2IbmIConnection'
              description: The connection details for the DB2 IBMi database
            tables:
              type: array
              description: The list of tables to be captured from the DB2 IBMi database
              items:
                $ref: '#/components/schemas/StreamingTable'
              minItems: 1
      required:
        - connection
        - tables
    StreamingMySqlSource:
      allOf:
        - $ref: '#/components/schemas/StreamingSource'
        - type: object
          properties:
            connection:
              $ref: '#/components/schemas/StreamingMySqlConnection'
              description: The connection details for the MySQL database
            tables:
              type: array
              description: The list of tables to be captured from the MySQL database
              items:
                $ref: '#/components/schemas/StreamingTable'
              minItems: 1
      required:
        - connection
        - tables
    StreamingOracleSource:
      allOf:
        - $ref: '#/components/schemas/StreamingSource'
        - type: object
          properties:
            connection:
              $ref: '#/components/schemas/StreamingOracleConnection'
              description: The connection details for the Oracle database
            tables:
              type: array
              description: The list of tables to be captured from the Oracle database
              items:
                $ref: '#/components/schemas/StreamingTable'
              minItems: 1
      required:
        - connection
        - tables
    StreamingPostgresSource:
      allOf:
        - $ref: '#/components/schemas/StreamingSource'
        - type: object
          properties:
            connection:
              $ref: '#/components/schemas/StreamingPostgresConnection'
              description: The connection details for the Postgres database
            tables:
              type: array
              description: The list of tables to be captured from the Postgres database
              items:
                $ref: '#/components/schemas/StreamingTable'
              minItems: 1
      required:
        - connection
        - tables
    StreamingSqlServerSource:
      allOf:
        - $ref: '#/components/schemas/StreamingSource'
        - type: object
          properties:
            connection:
              $ref: '#/components/schemas/StreamingSqlServerConnection'
              description: The connection details for the SQL Server database
            tables:
              type: array
              description: The list of tables to be captured from the SQL Server database
              items:
                $ref: '#/components/schemas/StreamingTable'
              minItems: 1
      required:
        - connection
        - tables
    StreamingAbsTarget:
      allOf:
        - $ref: '#/components/schemas/StreamingTarget'
        - type: object
          properties:
            accountKey:
              $ref: '#/components/schemas/StreamingSecretReference'
              description: The ABS account key for the associated ABS account
            accountName:
              type: string
              description: The ABS account name to store the Avro data files
              example: abs-account-name
              minLength: 1
            container:
              type: string
              description: The name of the ABS container to store the Avro data files
              example: streaming-container
              minLength: 1
            decimalMapping:
              type: string
              description: >-
                Determines the way decimal data is written in the Avro data
                files. If you are using the Redshift pre-built pipeline, you
                MUST use LOGICAL
              enum:
                - LEGACY
                - LOGICAL
            prefix:
              type: string
              description: The name of the prefix to use when storing the Avro data files
              example: streaming-prefix
      required:
        - accountKey
        - accountName
        - container
    StreamingS3Target:
      allOf:
        - $ref: '#/components/schemas/StreamingTarget'
        - type: object
          properties:
            bucket:
              type: string
              description: The name of the S3 bucket to store the Avro data files
              example: streaming-bucket
              minLength: 1
            decimalMapping:
              type: string
              description: >-
                Determines the way decimal data is written in the Avro data
                files. If you are using the Redshift pre-built pipeline, you
                MUST use LOGICAL
              enum:
                - LEGACY
                - LOGICAL
            prefix:
              type: string
              description: The name of the prefix to use when storing the Avro data files
              example: streaming-prefix
      required:
        - bucket
    StreamingSnowflakeTarget:
      allOf:
        - $ref: '#/components/schemas/StreamingTarget'
        - type: object
          properties:
            connection:
              $ref: '#/components/schemas/StreamingSnowflakeConnection'
              description: The details of the Snowflake connection to use
            database:
              type: string
              description: The database to use when connecting to the Snowflake instance
              example: streaming-database
              minLength: 1
            role:
              type: string
              description: The role to use when connecting to the Snowflake database
              example: streaming-role
              minLength: 1
            stageName:
              type: string
              description: >-
                The name of the stage to use to store the Avro data files in the
                Snowflake database
              example: streaming-stage-schema
              minLength: 1
            stagePrefix:
              type: string
              description: >-
                The prefix of the stage to use to store the Avro data files in
                the Snowflake database
              example: streaming-stage-schema
            stageSchema:
              type: string
              description: >-
                The schema that contains the stage to use to store the Avro data
                files in the Snowflake database
              example: streaming-stage-schema
              minLength: 1
            tablePrefixType:
              type: string
              description: >-
                Determines the naming convention of the tables created in the
                target database
              enum:
                - SOURCE_DATABASE_AND_SCHEMA
                - PREFIX
                - NONE
            tableSchema:
              type: string
              description: >-
                The schema in which to create the tables that will store the
                streamed data in the Snowflake database
              example: streaming-stage-schema
              minLength: 1
            temporalMapping:
              type: string
              description: >-
                Determines the way that datetime data is written into the target
                database
              enum:
                - NATIVE
                - EPOCH
            transformationType:
              type: string
              description: >-
                Determines the way the data is transformed into the target
                database
              enum:
                - COPY_TABLE
                - COPY_TABLE_SOFT_DELETE
                - CHANGE_LOG
            warehouse:
              type: string
              description: The warehouse to use when connecting to the Snowflake database
              example: streaming-warehouse
              minLength: 1
      required:
        - connection
        - database
        - role
        - stageName
        - stageSchema
        - tablePrefixType
        - tableSchema
        - transformationType
        - warehouse
    StreamingSource:
      type: object
      discriminator:
        propertyName: type
      properties:
        type:
          type: string
          description: The type of source for the streaming pipeline
          enum:
            - db2ibmi
            - mysql
            - oracle
            - postgres
            - sqlserver
    StreamingDb2IbmIConnection:
      type: object
      properties:
        host:
          type: string
          description: The host address of the DB2 IBMi database server
          example: 127.0.0.1
          minLength: 1
        jdbcProperties:
          type: object
          additionalProperties:
            type: string
          description: >-
            Any JDBC connection properties to be used when connecting to the DB2
            IBMi database
          example:
            date format: ymd
        password:
          $ref: '#/components/schemas/StreamingSecretReference'
          description: The details of the password for the associated username
        port:
          type: integer
          format: int32
          description: The port number of the DB2 IBMi database
          example: 8471
        username:
          type: string
          description: The username of the account used to connect to the DB2 IBMi database
          example: db2_streaming_user
          minLength: 1
      required:
        - host
        - password
        - port
        - username
    StreamingTable:
      type: object
      properties:
        schema:
          type: string
          description: The name of the database schema
          example: SCHEMA_A
          minLength: 1
        table:
          type: string
          description: The name of the database table
          example: TABLE_A
          minLength: 1
      required:
        - schema
        - table
    StreamingMySqlConnection:
      type: object
      properties:
        host:
          type: string
          description: The host address of the MySQL database server
          example: 127.0.0.1
          minLength: 1
        jdbcProperties:
          type: object
          additionalProperties:
            type: string
          description: >-
            Any JDBC connection properties to be used when connecting to the
            MySQL database
          example:
            FailoverMode: extended
        password:
          $ref: '#/components/schemas/StreamingSecretReference'
          description: The details of the password for the associated username
        port:
          type: integer
          format: int32
          description: The port number of the MySQL database
          example: 3306
        username:
          type: string
          description: The username of the account used to connect to the MySQL database
          example: mysql_streaming_user
          minLength: 1
      required:
        - host
        - password
        - port
        - username
    StreamingOracleConnection:
      type: object
      properties:
        database:
          type: string
          description: The name of the Oracle database
          example: SAAS_SALES
          minLength: 1
        host:
          type: string
          description: The host address of the Oracle database server
          example: 127.0.0.1
          minLength: 1
        jdbcProperties:
          type: object
          additionalProperties:
            type: string
          description: >-
            Any JDBC connection properties to be used when connecting to the
            Oracle database
          example:
            defaultRowPrefetch: '15'
        password:
          $ref: '#/components/schemas/StreamingSecretReference'
          description: The details of the password for the associated username
        pdb:
          type: string
          description: The name of the Oracle pluggable database
          example: SAAS_SALES_PDB
        port:
          type: integer
          format: int32
          description: The port number of the Oracle database
          example: 1521
        username:
          type: string
          description: The username of the account used to connect to the Oracle database
          example: oracle_streaming_user
          minLength: 1
      required:
        - database
        - host
        - password
        - port
        - username
    StreamingPostgresConnection:
      type: object
      properties:
        database:
          type: string
          description: The name of the Postgres database
          example: SAAS_SALES
          minLength: 1
        host:
          type: string
          description: The host address of the Postgres database server
          example: 127.0.0.1
          minLength: 1
        jdbcProperties:
          type: object
          additionalProperties:
            type: string
          description: >-
            Any JDBC connection properties to be used when connecting to the
            Postgres database
          example:
            ssl: 'true'
        password:
          $ref: '#/components/schemas/StreamingSecretReference'
          description: The details of the password for the associated username
        port:
          type: integer
          format: int32
          description: The port number of the Postgres database
          example: 5432
        username:
          type: string
          description: The username of the account used to connect to the Postgres database
          example: postgres_streaming_user
          minLength: 1
      required:
        - database
        - host
        - password
        - port
        - username
    StreamingSqlServerConnection:
      type: object
      properties:
        database:
          type: string
          description: The name of the SQL Server database
          example: SAAS_SALES
          minLength: 1
        host:
          type: string
          description: The host address of the SQL Server database server
          example: 127.0.0.1
          minLength: 1
        jdbcProperties:
          type: object
          additionalProperties:
            type: string
          description: >-
            Any JDBC connection properties to be used when connecting to the SQL
            Server database
          example:
            queryTimeout: '60'
        password:
          $ref: '#/components/schemas/StreamingSecretReference'
          description: The details of the password for the associated username
        port:
          type: integer
          format: int32
          description: The port number of the SQL Server database
          example: 1433
        username:
          type: string
          description: >-
            The username of the account used to connect to the SQL Server
            database
          example: sqlserver_streaming_user
          minLength: 1
      required:
        - database
        - host
        - password
        - port
        - username
    StreamingTarget:
      type: object
      discriminator:
        propertyName: type
      properties:
        type:
          type: string
          description: The type of target for the streaming pipeline
          enum:
            - abs
            - s3
            - snowflake
    StreamingSecretReference:
      type: object
      properties:
        secretKey:
          type: string
          description: The key of the secret
          example: the-secret-key
        secretLocation:
          type: string
          description: The location of the secret
          example: the-secret-location
        secretName:
          type: string
          description: The name of the secret
          example: the-secret-name
          minLength: 1
        secretType:
          type: string
          description: The cloud service that hosts the secret
          enum:
            - AWS_SECRETS_MANAGER
            - AZURE_KEY_VAULT
            - GOOGLE_SECRET_MANAGER
      required:
        - secretName
        - secretType
    StreamingSnowflakeConnection:
      type: object
      properties:
        accountName:
          type: string
          description: The account name for the Snowflake connection
          example: snowflake-account-name
          minLength: 1
        authentication:
          description: The authentication details for the Snowflake connection
          oneOf:
            - $ref: '#/components/schemas/StreamingKeyPairAuthentication'
            - $ref: '#/components/schemas/StreamingPasswordAuthentication'
        jdbcProperties:
          type: object
          additionalProperties:
            type: string
          description: >-
            Any JDBC connection properties to be used when connecting to the
            Snowflake database
          example:
            loginTimeout: '120'
        username:
          type: string
          description: The username for the Snowflake connection
          example: snowflake-username
          minLength: 1
      required:
        - accountName
        - authentication
        - username
    StreamingKeyPairAuthentication:
      allOf:
        - $ref: '#/components/schemas/StreamingAuthentication'
        - type: object
          properties:
            passphrase:
              $ref: '#/components/schemas/StreamingSecretReference'
              description: The details of the passphrase for key-pair based authentication
            privateKey:
              $ref: '#/components/schemas/StreamingSecretReference'
              description: The details of the private key for key-pair based authentication
      required:
        - privateKey
    StreamingPasswordAuthentication:
      allOf:
        - $ref: '#/components/schemas/StreamingAuthentication'
        - type: object
          properties:
            password:
              $ref: '#/components/schemas/StreamingSecretReference'
              description: The details for password based authentication
      required:
        - password
    StreamingAuthentication:
      discriminator:
        propertyName: type
      properties:
        type:
          type: string
      required:
        - type
  securitySchemes:
    bearerAuth:
      bearerFormat: JWT
      description: a valid bearer token
      scheme: bearer
      type: http

````